﻿
public class MemKey_Cfg {
    /// <summary>
    /// GM号列表
    /// </summary>
    /// <returns></returns>
    public static readonly string GM_uids_hash = "gamecfg-GM_uids";
    
}
public class MemKey_Game
{
    #region"   世界 Boss    "

    /// <summary>
    /// 世界boss,按照小时分场次
    /// </summary>
    /// <param name="zoneid"></param>
    /// <param name="uid"></param>
    /// <returns></returns>
    public static string BossFight_Damage_byDateHour_zset(int zoneid,int  bossid, string dateHour)
    {
        return $"gamerun-BossFight-byDateHour-zone{zoneid}-boss{bossid}-{dateHour}";
    }

    #endregion

    #region '   公会   '
    /// <summary>
    /// 公会
    /// </summary>
    /// <param name="zoneid"></param>
    /// <param name="guildId"></param>
    /// <returns></returns>
    public static string Guild(int zoneid,int guildId) => $"guild-{guildId}-zone{zoneid}";
    #endregion
}

public class MemKey_User
{

    #region"    辅助方法  "

    /// <summary>
    /// 是否使用短名称
    /// </summary>
    /// <returns></returns>
    private static bool bUseShort()
    {
        //        return true;  # 全部启用
        return Config.GameOnline;
    }

    /// <summary>
    /// key前缀
    /// </summary>
    /// <param name="zoneid"></param>
    /// <param name="uid"></param>
    /// <returns></returns>
    private static string Key_(int zoneid, string uid)
    {
        return bUseShort() ? $"u-{uid}-{zoneid}" : $"user-{uid}-zone{zoneid}";
    }

    #endregion

    #region"    Mail 邮件    "

    /// <summary>
    /// 玩家邮件 - 当前的maxid
    /// </summary>
    /// <param name="zoneid"></param>
    /// <param name="uid"></param>
    /// <returns></returns>
    public static string Mail_CurId_int(int zoneid, string uid)
    {
        return Key_(zoneid, uid) + (bUseShort() ? "-m-ci" : "-mail-curid");
    }

    /// <summary>
    /// 玩家邮件 - 已领取到的系统邮件id集合
    /// </summary>
    /// <param name="zoneid"></param>
    /// <param name="uid"></param>
    /// <returns></returns>
    public static string Mail_SysRecord_set(int zoneid, string uid)
    {
        return Key_(zoneid, uid) + (bUseShort() ? "-m-s" : "-mail-sysrecord");
    }

    /// <summary>
    /// 玩家邮件 - 邮件列表
    /// </summary>
    /// <param name="zoneid"></param>
    /// <param name="uid"></param>
    /// <returns></returns>
    public static string Mail_Queue_hash(int zoneid, string uid)
    {
        return Key_(zoneid, uid) + (bUseShort() ? "-m-q" : "-mail-queue");
    }

    #endregion

    #region '   公会  '
    /// <summary>
    /// 玩家公会信息
    /// </summary>
    /// <param name="uid"></param>
    /// <param name="zoneid"></param>
    /// <returns></returns>
    public static string Guild(string uid, int zoneid) => $"{Key_(zoneid, uid)}-guild";
    #endregion
}
